lukkien/urls.py
from django.contrib import admin
from django.urls import path
from django.conf import settings
from lukkien.contacts.views import contact_us, sign_up
from lukkien.contacts.api import api_paths
from lukkien.contacts.demo import populate, reset

urlpatterns = [
    path('admin/', admin.site.urls),
    path('contact_us/', contact_us),
    path('sign_up/', sign_up),
] + api_paths

# Don't let users delete the prod database...
if settings.DEBUG:
    urlpatterns += [
        path('demo/populate/<int:num>/', populate),
        path('demo/reset/', reset),
    ]

lukkien/contacts/models.py
from django.db import models
from lukkien.contacts.validators import is_phone_number, is_postal_code


class Contact(models.Model):
    email = models.EmailField(primary_key=True, max_length=100)
    first_name = models.CharField(max_length=50)
    last_name = models.CharField(max_length=50)
    phone_number = models.CharField(max_length=14,
                                    validators=[is_phone_number])
    date_of_birth = models.DateField(blank=True, null=True)
    postal_code = models.CharField(max_length=6, blank=True,
                                   validators=[is_postal_code])
    city = models.CharField(max_length=50, blank=True)
    street = models.CharField(max_length=50, blank=True)
    house_number = models.PositiveIntegerField(blank=True, null=True)

lukkien/contacts/forms.py
from django import forms
from lukkien.contacts.validators import is_postal_code, is_phone_number
from lukkien.contacts.fields import PhoneField, PostalCodeField


class DateOfBirthInput(forms.widgets.DateInput):
    template_name = "forms/widgets/dob.html"


class PhoneInput(forms.widgets.TextInput):
    template_name = "forms/widgets/phone.html"


class ContactShortForm(forms.Form):
    first_name = forms.CharField(label="First Name", max_length=50)
    last_name = forms.CharField(label="Last Name", max_length=50)
    email = forms.EmailField(max_length=100)
    phone_number = PhoneField(label="Phone Number", max_length=20,
                              validators=[is_phone_number], widget=PhoneInput)
    date_of_birth = forms.DateField(label="Date of Birth",
                                    widget=DateOfBirthInput)


class ContactLongForm(ContactShortForm):
    date_of_birth = None
    house_number = forms.IntegerField(min_value=0)
    street = forms.CharField(max_length=50)
    postal_code = PostalCodeField(max_length=7,
                                   validators=[is_postal_code])
    city = forms.CharField(max_length=50)

lukkien/contacts/views.py
from django.shortcuts import render

from lukkien.contacts.forms import ContactShortForm, ContactLongForm
from lukkien.const import HTTPConsts
from lukkien.contacts.models import Contact


def contact_us(request):
    """
    View for the 'Contact Us' form. If validation is successful then we return
    forward the request to the sign_up view (we don't redirect in order to
    preserve the user's form data).
    """
    if request.method == HTTPConsts.POST:
        form = ContactShortForm(request.POST)
        if form.is_valid():
            Contact.objects.update_or_create(email=form.cleaned_data['email'],
                                             defaults=form.cleaned_data)
            return sign_up(request, follow_up=True)
    else:
        form = ContactShortForm()
    return render(request, 'forms/contact_us.html', {'form': form})


def sign_up(request, follow_up=None):
    """
    View for the 'Sign Up' form. If follow_up==True we render a modified version
    of the form, which partially populates the form with the data we received
    from the 'contact_us' view.

    If validation is successful we render a simple 'thank you' template.
    """
    if request.method == HTTPConsts.POST:
        form = ContactLongForm(request.POST)
        if form.is_valid():
            Contact.objects.update_or_create(email=form.cleaned_data['email'],
                                             defaults=form.cleaned_data)
            return render(request, 'thank_you.html', {})
        elif follow_up:
            return render(request, 'forms/sign_post_contact.html',
             {'form': form,
              'follow_up': True})
    else:
        form = ContactLongForm()

    return render(request, 'forms/sign_up.html', {'form': form})

lukkien/contacts/templates/base.html
{% load widget_tweaks %}
{% load static %}
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <script src="{% static "js/jquery-3.3.1.slim.min.js" %}"></script>
  <script src="{% static "js/moment.min.js" %}"></script>
  <script src="{% static "js/bootstrap.min.js" %}"></script>
  <script src="{% static "js/popper.min.js" %}"></script>
  <script src="{% static "js/tempusdominus-bootstrap-4.min.js" %}"></script>
  <link rel="stylesheet" href="{% static "css/bootstrap4_1_3.min.css" %}">
  <link rel="stylesheet" href="{% static "css/tempusdominus-bootstrap-4.min.css" %}" />
  <link rel="stylesheet" href="https://netdna.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.css">
  <title>
    {% block title %}
    {% endblock %}
  </title>
  <style>
      label {
      margin-bottom: 0px;
    }
    html, body {
      height: 100%;
    }
    .form-container {
      background-color: #e4f1f8;
      padding: 20px;
      min-height: 100%;
      height: fit-content;
      border-color: #cedae1;
      border-right-style: solid;
      border-right-width: 4px;
    }
  </style>
  {% block stylings %}
  {% endblock %}
</head>
<body {% block delay_page %}{% endblock %}>
<div class="container-fluid h-100">
  <div class="row h-100">
<div class="text-center form-container col-lg-6 offset-lg-3 col-md-6 offset-md-3 col-xs-12 col-sm-8 offset-sm-2">
  <h1 class="display-4">{% block form_header %}{% endblock %}</h1>
  <h6 style="margin-bottom: 1em">{% block form_desc %}{% endblock %}</h6>
  {% block content %}
  {% endblock %}
</div>
</div>
</div>
{% block inline_javascript %}
{% endblock %}
</body>
</html>

lukkien/contacts/templates/forms/base_form.html
{% extends "base.html" %}
{% load widget_tweaks %}
{% block stylings %}
  <style>
    .alert-danger {
      width: 96%;
      padding-left: 2%;
      margin-left: 2%;
    }
    #id_country_code {
      flex: none;
      width: 62px;
      padding: 6px;
    }
  </style>
{% endblock %}

{% block delay_page %}style="display: none"{% endblock %}

{% block content %}
  <form id="id_form" action="{% block action %}{% endblock %}" method="post">
    {% csrf_token %}
    {% for field in form.visible_fields %}
      <div class="form-group">
        <div class="input-group">
          <div class="input-group-prepend">
            <span class="input-group-text">{{ field.label }}</span>
          </div>
          {% if field.errors and not follow_up%}
            {% render_field field class="form-control is-invalid" %}
          {% elif follow_up and field.data %}
            {% render_field field class="form-control" readonly="" %}
          {% else %}
            {% render_field field class="form-control" %}
          {% endif %}
        </div>
        {% if field.errors and not follow_up%}
          {% for error in field.errors %}
            <div class="alert-danger">{{ error }}</div>
          {% endfor %}
        {% endif %}
      </div>
    {% endfor %}
    <input type="submit" class="float-right btn btn-primary" value="Submit">
  </form>
{% endblock %}

{% block inline_javascript %}
  <script type="text/javascript">
    $(function () {
      $('#id_date_of_birth').datetimepicker({
        format: 'L',
        viewMode: 'decades',
        maxDate: moment().subtract(18, 'years'),
        minDate: moment().subtract(125, 'years'),
        date: moment($("#id_date_of_birth").val())
      });
    });

    function handle_phone_data(e){
      e.preventDefault();
      let form = $(this);
      let phone_number = $('#id_phone_number').val();
      let country_code = $('#id_country_code').val().replace("+", "").replace(" ", "");
      phone_number = country_code + phone_number;
      let cloned_form = form.clone();
      cloned_form.find("#id_phone_number").val(phone_number);
      $("body").append(cloned_form);
      cloned_form.submit();
    }

    function set_country_code(){
      let phone_number = $('#id_phone_number');
      let country_select = $('#id_country_code');
      let phone_data = phone_number.val();
      if (!phone_data){return}
      country_select.children("option").each(function(i, child){
        let country_code = child.text;
        let country_code_num = country_code.replace("+", "").replace(" ", "");
        if (phone_data.indexOf(country_code_num) === 0) {
          country_select.val(country_code);
          phone_number.val(phone_data.replace(country_code_num, "", 1));
        }
      });
    }

    $( document ).ready(function() {
      set_country_code();
      $('#id_form').submit(handle_phone_data);
      $('body').show();
    });

  </script>
{% endblock %}

lukkien/contacts/templates/forms/contact_us.html
{% extends "forms/base_form.html" %}

{% block title %}Contact Us{% endblock %}

{% block form_header %}Contact Us{% endblock %}

{% block action %}/contact_us/{% endblock %}

{% block form_desc %}
  Thank you for your interest. Please provide your contact details, and a
  representative will contact you soon.
{% endblock %}

lukkien/contacts/templates/forms/sign_post_contact.html
{% extends "forms/sign_up.html" %}

{% block form_desc %}You should hear from one of our agents soon. In the meantime,
  would you like to create and account?
{% endblock %}

lukkien/contacts/templates/forms/sign_up.html
{% extends "forms/base_form.html" %}

{% block title %}Sign Up{% endblock %}

{% block form_header %}Account Creation{% endblock %}

{% block action %}/sign_up/{% endblock %}

{% block form_desc %}
{% endblock %}

lukkien/contacts/templates/forms/widgets/dob.html
{% include "django/forms/widgets/input.html" %}
<div class="input-group-append" data-target="#id_date_of_birth" data-toggle="datetimepicker">
      <div class="input-group-text"><i class="fa fa-calendar"></i></div>
    </div>

lukkien/contacts/templates/forms/widgets/phone.html
<select class="form-control" id="id_country_code" {% if "readonly" in widget.attrs %}readonly=""{% endif %}>
  <option>+ 1</option>
  <option>+ 31</option>
</select>
{% include "django/forms/widgets/input.html" %}

lukkien/contacts/templates/thank_you.html
{% extends "base.html" %}

{% block title %}Thank You!{% endblock %}

{% block form_header %}Thank You{% endblock %}

{% block form_desc %}
  Your new account has been created. Have a nice day.
{% endblock %}